/**
 * Assignment #9: POSIX select() and Socket Connection (Client)
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "globals.h"

/**
 * The first child process.
 * @param fd the pipe file descriptors.
 */
void child_1(int fd[])
{
    // Don't need the READ end of the pipe.
    close(fd[READ_FD]);

    int n = 0;
    char buffer[BUFFER_SIZE];

    while (1)
    {
        sprintf(buffer, "Message %d", ++n);
        write(fd[WRITE_FD], buffer, strlen(buffer) + 1);

        sleep(rand()%5 + 1);
    }
}

/**
 * The second child process.
 * @param fd the pipe file descriptors.
 */
void child_2(int fd[])
{
    // Don't need the READ end of the pipe.
    close(fd[READ_FD]);

    char buffer[BUFFER_SIZE];

    while (1)
    {
        printf("\nType something!\n");

        fgets(buffer, BUFFER_SIZE, stdin);
        buffer[strlen(buffer) - 1] = '\0';  // remove ending \n
        write(fd[WRITE_FD], buffer, strlen(buffer) + 1);
    }
}
