/**
 * Assignment #9: POSIX select() and Socket Connection (Client)
 * Sample Solution
 *
 * Instructor: Ron Mak
 * CMPE 142 Operating Systems
 * Computer Engineering Department
 * San Jose State University
 */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include "globals.h"

int parent(int fd_1[], int fd_2[], char *ip_address);

void child_1(int fd[]);
void child_2(int fd[]);

int main(int argc, char *argv[])
{
    if (argc != 2)
    {
        printf("*** Usage: <IP address of server>\n");
        return -1;
    }

    int fd_1[2];  // file descriptors for pipe #1
    int fd_2[2];  // file descriptors for pipe #2

    // Create pipe #1.
    pid_t pipe_id_1 = pipe(fd_1);
    if (pipe_id_1 < 0)
    {
        perror("Error: pipe() #1");
        return -1;
    }

    // Create pipe #2.
    pid_t pipe_id_2 = pipe(fd_2);
    if (pipe_id_2 < 0)
    {
        perror("Error: pipe() #2");
        return -1;
    }

    int status = 0;

    // Fork child process #1.
    pid_t pid_1 = fork();
    if (pid_1 > 0)
    {
        // Fork child process #2.
        pid_t pid_2 = fork();
        if (pid_2 > 0)
        {
            char *ip_address = argv[1];
            status = parent(fd_1, fd_2, ip_address);
        }
        else
        {
            child_2(fd_2);
        }
    }
    else
    {
        child_1(fd_1);
    }

    return status;
}
